# 12nov23 Software Lab. Alexander Burger

(symbols '(android pico))

(local) STREAM_MUSIC

(de STREAM_MUSIC . 3)  # AudioManager


(symbols '(radio android pico))

(local) (radioStream stopStream setRadioAlarm runRadioAlarm clrRadioAlarm)

(de radioStream (This)  # +Station
   (put!> (bulk) 'st This)
   (catch '("Exception")
      (if *MediaPlayer
         (java @ 'reset)
         (setq *MediaPlayer (java "android.media.MediaPlayer" T))
         (java *MediaPlayer 'setAudioStreamType STREAM_MUSIC) )
      (java *MediaPlayer 'setDataSource CONTEXT
         (java "android.net.Uri" 'parse (: url)) )
      (java *MediaPlayer 'prepare)
      (java *MediaPlayer 'start)
      (status (: nm))
      (wake T)
      (tell 0 'setq
         '*Wake (lit *Wake)
         '*MediaPlayer (lit *MediaPlayer) ) )
   (finish
      (symbols '(radio android pico)
         (pool "db/radio")
         (stopStream) ) ) )

(de stopStream ()
   (tell 0 'off '*Wake '*MediaPlayer)
   (when *MediaPlayer
      (catch '("Exception")
         (java @ 'release) ) )
   (status)
   (wake NIL)
   (off *MediaPlayer)
   (put!> (bulk) 'st NIL)
   (del
      '(symbols '(radio android pico) (pool "db/radio") (stopStream))
      '*Bye ) )

(de setRadioAlarm (This Tim)
   (put!> (bulk) 'act T)
   (let D (date)
      (when (>= (time) Tim)
         (inc 'D) )
      (alarm 81 (cons D Tim) "radio/alarm.l" "radio/App.l") ) )

(de runRadioAlarm ()
   (with (bulk 'ast)
      (radioStream This)
      (setRadioAlarm This (bulk 'tim)) ) )

(de clrRadioAlarm ()
   (alarm 81)
   (put!> (bulk) 'act NIL) )
